/*
 * --COPYRIGHT--,BSD Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved. Redistribution and use in source and binary
 * forms, with or without modification, are permitted provided that the
 * following conditions are met: * Redistributions of source code must
 * retain the above copyright notice, this list of conditions and the
 * following disclaimer. * Redistributions in binary form must reproduce
 * the above copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided with
 * the distribution. * Neither the name of Texas Instruments Incorporated
 * nor the names of its contributors may be used to endorse or promote
 * products derived from this software without specific prior written
 * permission. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE. --/COPYRIGHT--
 */

//******************************************************************************
//  Jose I Quinones
//  Texas Instruments Inc.
//  June 2009
//  Built with IAR Embedded Workbench Version: 3.42A
//******************************************************************************
//Firmware Bytes
// |Y3|Y2|Y1|Y0|M3|M2|M1|M0| Where Y3:Y0 = 4 bit code for year from 2007 to 2022 and M3:M0 = 4 bit code for month from Jan (0x00) to Dec (0x0B)
// |D4|D3|D2|D1|D0|H4|H3|H2| Where D4:D0 = 5 bit code for day from 1 (0x00) to 31 (0x1E) and H4:H2 = 3 MSB code for Hour from 0:00 AM (0x00) to .
// |H1|H0|N5|N4|N3|N2|N1|N0| Where H1:H0  = 2 MSB code for Hour and N5:N0 = 6 bit code for minute from 0 to 63.

#define FIRST_YEAR      2007
#define CURRENT_YEAR    2009                            // Change This During Release (IF NEEDED)
#define RELEASE_YEAR    CURRENT_YEAR - FIRST_YEAR

#define JAN             0x00
#define FEB             0x01
#define MAR             0x02
#define APR             0x03
#define MAY             0x04
#define JUN             0x05
#define JUL             0x06
#define AUG             0x07
#define SEP             0x08
#define OCT             0x09
#define NOV             0x0A
#define DEC             0x0B
#define RELEASE_MONTH   APR                             // Change This During Release (IF NEEDED)

#define CURRENT_DAY     2                               // Change This During Release (IF NEEDED)
#define RELEASE_DAY     CURRENT_DAY - 1

#define RELEASE_HOUR    0x03                             // Change This During Release (IF NEEDED)

#define RELEASE_MINUTE  0x30                              // Change This During Release (IF NEEDED)

#define FIRMWARE_RELEASE_3      (RELEASE_YEAR << 4) + RELEASE_MONTH
#define FIRMWARE_RELEASE_2      (RELEASE_DAY << 3) + ((RELEASE_HOUR & 0x1C) >> 2)
#define FIRMWARE_RELEASE_1      ((RELEASE_HOUR & 0x03) << 6) + RELEASE_MINUTE

//#define FIRMWARE_RELEASE_L      (RELEASE_DAY << 12) + (RELEASE_HOUR << 8) + RELEASE_MINUTE
